#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>

int main(void)
{
	int fd = -1;
	char buffer[256];
	int pid;
	
	setgroups(0, NULL);
	setgid(0); setuid(0);
 		

	memset(buffer, 0, 256);
	
	if ((fd = open("/var/run/inetd.pid", O_RDONLY)) == -1)
	{
		perror("Couldn't open pid file");
		goto EXIT;
	}
	if (read(fd, buffer, 255) == -1)
	{
		perror("Couldn't read from pid file");
		goto EXIT;
	}
	pid = atoi(buffer);
	if (pid <= 1)
	{
		perror("Bad pid value");
		goto EXIT;
	}
	if (kill(pid, SIGHUP) == -1)
	{
		perror("Unable to send SIGHUP");
		goto EXIT;
	}
	
EXIT:
	if (fd != -1)
		close(fd);

	return 0;
}
